<template>
  <tr>
    <appTableTd>{{ fullName }} </appTableTd>
    <appTableTd>{{ position }} </appTableTd>
    <appTableTd>{{ location }} </appTableTd>
    <appTableTd>{{ legalMaxWeeklyHours }} </appTableTd>
    <appTableTd>
      <appBtn @click="$emit('edit')"> Editar </appBtn>
    </appTableTd>
  </tr>
</template>

<script>
import apiMixin from '../../mixins/api';
export default {
  name: 'userCard',
  mixins: [apiMixin],
  props: {
    user: {
      type: Object,
      default: () => ({}),
    },
  },
  computed: {
    fullName() {
      return `${this.user.firstName} ${this.user.lastName}`;
    },
    position() {
      try {
        const positions = this.getPosition().map(({ name }) => name);
        const position = positions.join(', ').trim();
        return position || 'Sin cargo';
      } catch (e) {
        return 'Desconocido';
      }
    },
    location() {
      try {
        let location = this.getLocation().map(({ name }) => name);
        location = location.join(', ').trim();
        return location || 'Sin localizacion';
      } catch (e) {
        return 'Desconocido';
      }
    },
    legalMaxWeeklyHours() {
      try {
        const { legalMaxWeeklyHours } = this.getContract();
        return legalMaxWeeklyHours;
      } catch (e) {
        return 'Desconocido';
      }
    },
  },
  methods: {
    getPosition() {
      const positionId = this.user.positionId || [];
      return this.positionList.filter(
        ({ id }) => !!positionId.find((entry) => id === entry)
      );
    },
    getLocation() {
      const locationId = this.user.locationId || [];
      return this.locationList.filter(
        ({ id }) => !!locationId.find((entry) => id === entry)
      );
    },
    getContract() {
      const contract = this.user.contract;
      return this.contractList.find(({ id }) => contract === id);
    },
  },
};
</script>

<style></style>
